-- перечисляем будущие шаблонов погрузки
local _ru_desants = {};
local _ru_pzrk = {};
local _ru_minomet_H = {};
local _ru_minomet_L = {};

local _us_pehota = {};
local _us_pzrk = {};
local _us_minomet_H = {};
local _us_minomet_L = {};

local _gr_desants = {};
local _gr_pzrk = {};
local _gr_minomet_H = {};
local _gr_minomet_L = {};

--шаблоны погрузки
--Infantry AK - РФ солдат
--Paratrooper AKS-74 - РФ десант с АК
--Paratrooper RPG-16 - РФ десант с граником
--Soldier AK - Грузия солдаты с АК 
--Soldier RPG - Грузия солдаты с граником
--Soldier M4 - США солдат с М4
--Soldier M249 - США солдат с пулемет

--SA-18 Igla-S comm - Стрела командир
--SA-18 Igla-S manpad - стрела стрелок
--Stinger comm - Стингер командир
--Stinger manpad - Стингер стрелок
--2B11 mortar - Миномет все страны

--создаем шаблоны погрузки
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 20, y = 15 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 15, y = 15 } });
table.insert(_ru_desants, { unitType = 'Paratrooper RPG-16', playerCanDrive = true, pointOffset = { x = 13, y = 15 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 15, y = 10 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 20, y = 20 } });
table.insert(_ru_desants, { unitType = 'Paratrooper RPG-16', playerCanDrive = true, pointOffset = { x = 24, y = 25 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 25, y = 20 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 28, y = 10 } });
table.insert(_ru_desants, { unitType = 'Paratrooper RPG-16', playerCanDrive = true, pointOffset = { x = 25, y = 25 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 30, y = 27 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 35, y = 15 } });
table.insert(_ru_desants, { unitType = 'Paratrooper RPG-16', playerCanDrive = true, pointOffset = { x = 30, y = 11 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 34, y = 10 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 30, y = 20 } });
table.insert(_ru_desants, { unitType = 'Paratrooper RPG-16', playerCanDrive = true, pointOffset = { x = 32, y = 25 } });
table.insert(_ru_desants, { unitType = 'Paratrooper AKS-74', playerCanDrive = true, pointOffset = { x = 25, y = 30 } });

table.insert(_ru_pzrk, { unitType = 'SA-18 Igla-S comm', playerCanDrive = true, pointOffset = { x = 10, y = 10 } });
table.insert(_ru_pzrk, { unitType = 'SA-18 Igla-S manpad', playerCanDrive = true, pointOffset = { x = 15, y = 15 } });
table.insert(_ru_pzrk, { unitType = 'Infantry AK', playerCanDrive = true, pointOffset = { x = 10, y = 15 } });
table.insert(_ru_pzrk, { unitType = 'Infantry AK', playerCanDrive = true, pointOffset = { x = 15, y = 10 } });

table.insert(_ru_minomet_H, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 26, y = 10 } });
table.insert(_ru_minomet_H, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 12, y = 10 } });
table.insert(_ru_minomet_H, { unitType = '2B11 mortar', playerCanDrive = false, pointOffset = { x = 10, y = 10 } });
table.insert(_ru_minomet_H, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 14, y = 10 } });
table.insert(_ru_minomet_H, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 18, y = 10 } });
table.insert(_ru_minomet_H, { unitType = '2B11 mortar', playerCanDrive = false, pointOffset = { x = 16, y = 10 } });
table.insert(_ru_minomet_H, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 20, y = 10 } });
table.insert(_ru_minomet_H, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 24, y = 10 } });
table.insert(_ru_minomet_H, { unitType = '2B11 mortar', playerCanDrive = false, pointOffset = { x = 22, y = 10 } });

table.insert(_ru_minomet_L, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 20, y = 10 } });
table.insert(_ru_minomet_L, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 12, y = 10 } });
table.insert(_ru_minomet_L, { unitType = '2B11 mortar', playerCanDrive = false, pointOffset = { x = 10, y = 10 } });
table.insert(_ru_minomet_L, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 14, y = 10 } });
table.insert(_ru_minomet_L, { unitType = 'Infantry AK', playerCanDrive = false, pointOffset = { x = 18, y = 10 } });
table.insert(_ru_minomet_L, { unitType = '2B11 mortar', playerCanDrive = false, pointOffset = { x = 16, y = 10 } });

table.insert(_us_pehota, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 20, y = 15 } });
table.insert(_us_pehota, { unitType = 'Soldier M249', playerCanDrive = true, pointOffset = { x = 15, y = 15 } });
table.insert(_us_pehota, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 10, y = 15 } });
table.insert(_us_pehota, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 15, y = 10 } });
table.insert(_us_pehota, { unitType = 'Soldier M249', playerCanDrive = true, pointOffset = { x = 20, y = 20 } });
table.insert(_us_pehota, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 20, y = 25 } });
table.insert(_us_pehota, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 25, y = 20 } });
table.insert(_us_pehota, { unitType = 'Soldier M249', playerCanDrive = true, pointOffset = { x = 20, y = 10 } });
table.insert(_us_pehota, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 10, y = 20 } });

table.insert(_us_pzrk, { unitType = 'Stinger comm', playerCanDrive = true, pointOffset = { x = 20, y = 15 } });
table.insert(_us_pzrk, { unitType = 'Stinger manpad', playerCanDrive = true, pointOffset = { x = 15, y = 15 } });
table.insert(_us_pzrk, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 10, y = 15 } });
table.insert(_us_pzrk, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 15, y = 10 } });

table.insert(_us_minomet_H, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 26, y = 10 } });
table.insert(_us_minomet_H, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 12, y = 10 } });
table.insert(_us_minomet_H, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 10, y = 10 } });
table.insert(_us_minomet_H, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 14, y = 10 } });
table.insert(_us_minomet_H, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 18, y = 10 } });
table.insert(_us_minomet_H, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 16, y = 10 } });
table.insert(_us_minomet_H, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 20, y = 10 } });
table.insert(_us_minomet_H, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 24, y = 10 } });
table.insert(_us_minomet_H, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 22, y = 10 } });

table.insert(_us_minomet_L, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 20, y = 10 } });
table.insert(_us_minomet_L, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 12, y = 10 } });
table.insert(_us_minomet_L, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 10, y = 10 } });
table.insert(_us_minomet_L, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 14, y = 10 } });
table.insert(_us_minomet_L, { unitType = 'Soldier M4', playerCanDrive = true, pointOffset = { x = 18, y = 10 } });
table.insert(_us_minomet_L, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 16, y = 10 } });

table.insert(_gr_desants, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 20, y = 15 } });
table.insert(_gr_desants, { unitType = 'Soldier RPG', playerCanDrive = true, pointOffset = { x = 15, y = 15 } });
table.insert(_gr_desants, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 10, y = 15 } });
table.insert(_gr_desants, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 15, y = 10 } });
table.insert(_gr_desants, { unitType = 'Soldier RPG', playerCanDrive = true, pointOffset = { x = 25, y = 20 } });
table.insert(_gr_desants, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 20, y = 20 } });
table.insert(_gr_desants, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 20, y = 25 } });
table.insert(_gr_desants, { unitType = 'Soldier RPG', playerCanDrive = true, pointOffset = { x = 25, y = 25 } });
table.insert(_gr_desants, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 20, y = 10 } });

table.insert(_gr_pzrk, { unitType = 'SA-18 Igla-S comm', playerCanDrive = true, pointOffset = { x = 10, y = 10 } });
table.insert(_gr_pzrk, { unitType = 'SA-18 Igla-S manpad', playerCanDrive = true, pointOffset = { x = 15, y = 15 } });
table.insert(_gr_pzrk, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 10, y = 15 } });
table.insert(_gr_pzrk, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 15, y = 10 } });

table.insert(_gr_minomet_H, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 26, y = 10 } });
table.insert(_gr_minomet_H, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 12, y = 10 } });
table.insert(_gr_minomet_H, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 10, y = 10 } });
table.insert(_gr_minomet_H, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 14, y = 10 } });
table.insert(_gr_minomet_H, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 18, y = 10 } });
table.insert(_gr_minomet_H, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 16, y = 10 } });
table.insert(_gr_minomet_H, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 20, y = 10 } });
table.insert(_gr_minomet_H, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 24, y = 10 } });
table.insert(_gr_minomet_H, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 22, y = 10 } });

table.insert(_gr_minomet_L, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 20, y = 10 } });
table.insert(_gr_minomet_L, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 12, y = 10 } });
table.insert(_gr_minomet_L, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 10, y = 10 } });
table.insert(_gr_minomet_L, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 14, y = 10 } });
table.insert(_gr_minomet_L, { unitType = 'Soldier AK', playerCanDrive = true, pointOffset = { x = 18, y = 10 } });
table.insert(_gr_minomet_L, { unitType = '2B11 mortar', playerCanDrive = true, pointOffset = { x = 16, y = 10 } });

local _r828_chanel = {};
table.insert(_r828_chanel, {Chanel = 1, Freq = 21500000});
table.insert(_r828_chanel, {Chanel = 2, Freq = 25675000});
table.insert(_r828_chanel, {Chanel = 3, Freq = 27000000});
table.insert(_r828_chanel, {Chanel = 4, Freq = 28000000});
table.insert(_r828_chanel, {Chanel = 5, Freq = 30000000});
table.insert(_r828_chanel, {Chanel = 6, Freq = 32000000});
table.insert(_r828_chanel, {Chanel = 7, Freq = 40000000});
table.insert(_r828_chanel, {Chanel = 8, Freq = 50000000});
table.insert(_r828_chanel, {Chanel = 9, Freq = 55525000});
table.insert(_r828_chanel, {Chanel = 10, Freq = 59975000});

local _veh_radios_list = {};
local _static_radios_list = {};

for _coalition_index, _coalition in pairs(env.mission.coalition) do --перебираем все коалиции
--	mission.controller.sendMessageForAll("Коалиция ".._coalition.name);

	for _country_index, _country in pairs(_coalition.country) do --перебираем все страны в коалиции
--		mission.controller.sendMessageForAll("Страна ".._country.id);

		if _country.vehicle and _country.vehicle.group then --если есть наземные юниты
			for _coalition_veh_groups_index, _coalition_veh_groups in ipairs(_country.vehicle.group) do--перебираем все группы в стране
				if not mission.model.groups[_coalition_veh_groups.name] then 
					mission.model:addGroup(_coalition_veh_groups.name);
				end --если группа не передана под управление SSE, то передаем
                --mission.model.groups[_coalition_groups.name]:addOnHitEventHandler(_onTransportHitEventHandler); --раскомментарить при использовании сначала скрипта высадки десанта при обстреле
				local sender_veh = mission.model.groups[_coalition_veh_groups.name]:getDCSWorldGroup();--получаем группу из ДКС
				local _all_veh_group_units = sender_veh:getUnits();--количество юнитов в группе
				for _coalition_veh_groups_unit_index, _coalition_veh_groups_unit in ipairs(_all_veh_group_units) do--перебираем все юниты группы
					local _coalition_veh_groups_unit_name = _coalition_veh_groups_unit:getName();		
					if not mission.model.units[_coalition_veh_groups_unit_name] then mission.model:addUnit(_coalition_veh_groups_unit_name); end --если юнит не передан под управление SSE, то передаем
					if _coalition_veh_groups_unit:hasAttribute('Infantry') then
						mission.model.groups[_coalition_veh_groups.name]:addAvalibleTransport('Mi-8MT');
						mission.model.groups[_coalition_veh_groups.name]:addAvalibleTransport('UH-1H');
						--mission.model.groups[_coalition_veh_groups.name]:addAvalibleTransport('BTR-80');
					end
					
					local _radio_transmit_veh = string.find(_coalition_veh_groups_unit_name, "@");
					if _radio_transmit_veh ~= nil then
						local _veh_point = _coalition_veh_groups_unit:getPoint();
						local _veh_radio_pos = { x = _veh_point.x, y = 200, z = _veh_point.z};
						local _chanel_veh = string.sub(_coalition_veh_groups_unit_name, _radio_transmit_veh + 1, _radio_transmit_veh + 1);
						local _transmit_on_move = string.sub(_coalition_veh_groups_unit_name, _radio_transmit_veh - 1, _radio_transmit_veh - 1);
						if _transmit_on_move ~= nil and _transmit_on_move ~= '' and string.upper(_transmit_on_move) == 'M' then
							_transmit_on_move = true;
						else
							_transmit_on_move = false;
						end
						if _chanel_veh ~= nil and _chanel_veh ~= '' and string.match(_chanel_veh,"%d") ~= nil then
							_chanel_veh = tonumber(_chanel_veh);
							if _chanel_veh == 0 then _chanel_veh = 10; end
							if _coalition.name == 'RED' then
								table.insert(_veh_radios_list, { radioSound = 'continue.ogg', radioPosition = _veh_radio_pos, radioModulation = radio.modulation.FM, repeatTransmit = true, radioFrequency = _r828_chanel[_chanel_veh].Freq, radioPower = 1, radioName = _coalition_veh_groups_unit_name, transmitOnMove = _transmit_on_move});
								trigger.action.radioTransmission('continue.ogg', _veh_radio_pos, radio.modulation.FM , true, _r828_chanel[_chanel_veh].Freq, 1, _coalition_veh_groups_unit_name);
							else
								table.insert(_veh_radios_list, { radioSound = 'continue.ogg', radioPosition = _veh_radio_pos, radioModulation = radio.modulation.AM, repeatTransmit = true, radioFrequency = 200000, radioPower = 1, radioName = _coalition_veh_groups_unit_name, transmitOnMove = _transmit_on_move});
								trigger.action.radioTransmission('continue.ogg', _veh_radio_pos, radio.modulation.AM , true, 200000, 1, _coalition_veh_groups_unit_name);
							end
						end
					end
				end
			end
		end
		
		if _country.helicopter and _country.helicopter.group then --если есть вертушки
			for _coalition_hel_groups_index, _coalition_hel_groups in ipairs(_country.helicopter.group) do--перебираем все группы в стране
				if not mission.model.groups[_coalition_hel_groups.name] then
					mission.model:addGroup(_coalition_hel_groups.name);
				end --если группа не передана под управление SSE, то передаем
				local sender_hel = mission.model.groups[_coalition_hel_groups.name]:getDCSWorldGroup();--получаем группу из ДКС
				if sender_hel ~= nil then
					local _all_hel_group_units = sender_hel:getUnits();--количество юнитов в группе
					for _coalition_hel_groups_unit_index, _coalition_hel_groups_unit in ipairs(_all_hel_group_units) do--перебираем все юниты группы
						local _coalition_hel_groups_unit_name = _coalition_hel_groups_unit:getName();		
						if not mission.model.units[_coalition_hel_groups_unit_name] then mission.model:addUnit(_coalition_hel_groups_unit_name); end --если юнит не передан под управление SSE, то передаем
						mission.model.units[_coalition_hel_groups_unit_name]:setTransportTask(true); --транспортная задача
					end
				end
			end
		end
		
		if _country.static and _country.static.group then
			for _static_group_index, _static_group in ipairs(_country.static.group) do --перебираем все группы статики в стране
--				mission.controller.sendMessageForAll("Группа ".._static_group.name);
				for _static_units_index, _static_units in ipairs(_static_group.units) do --перебираем все юниты группы статики в стране
--					mission.controller.sendMessageForAll("Юнит ".._static_units.name);	

					local _radio_transmit_stat = string.find(_static_units.name, "@");
					if _radio_transmit_stat ~= nil then
						local _stat_radio_pos = { x = _static_units.x, y = 200, z = _static_units.y};
						local _chanel_stat = string.sub(_static_units.name, _radio_transmit_stat+1, _radio_transmit_stat + 1);
						if _chanel_stat ~= nil and _chanel_stat ~= '' and string.match(_chanel_stat,"%d") ~= nil then
							_chanel_stat = tonumber(_chanel_stat);
							if _chanel_stat == 0 then _chanel_stat = 10; end
							if _coalition.name == 'RED' then
								table.insert(_static_radios_list, { radioSound = 'continue.ogg', radioPosition = _stat_radio_pos, radioModulation = radio.modulation.FM, repeatTransmit = true, radioFrequency = _r828_chanel[_chanel_stat].Freq, radioPower = 1, radioName = _static_units.name});
								trigger.action.radioTransmission('continue.ogg', _stat_radio_pos, radio.modulation.FM , true, _r828_chanel[_chanel_stat].Freq, 1, _static_units.name);
							else
								table.insert(_static_radios_list, { radioSound = 'continue.ogg', radioPosition = _stat_radio_pos, radioModulation = radio.modulation.AM, repeatTransmit = true, radioFrequency = 200000, radioPower = 1, radioName = _static_units.name});
								trigger.action.radioTransmission('continue.ogg', _stat_radio_pos, radio.modulation.AM , true, 200000, 1, _static_units.name);
							end
						end
					end

					local _pogruzka = string.find(_static_units.name, "PGRZ"); --проверяем есть ли в названии признак погрузочной зоны
					if _pogruzka ~= nil then --если есть
							
						local _cargo_place_point = { x = _static_units.x, y = 200, z = _static_units.y};
--						trigger.action.smoke(_cargo_place_point, trigger.smokeColor.Red);
						trigger.action.signalFlare(_cargo_place_point, trigger.flareColor.Red, 0);
						if _country.id == country.id.RUSSIA then --если строение России то

							local _cargo_place_ru1 = mission.model:addCargoPlace('Пункт подбора '.._static_units.name, _cargo_place_point, 150, coalition.side[_coalition.name]); --создаем зону погрузки для коалиции, к которой пренадлежит Россия
							mission.model.cargoPlaces[_cargo_place_ru1]:addCargoTemplate('des_ru_car1'.._static_units.name, 'Mi-8MT', 10, _ru_desants, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 }, country.id.RUSSIA, 'Десант');
							mission.model.cargoPlaces[_cargo_place_ru1]:addCargoTemplate('pzrk_ru_car1'.._static_units.name, 'Mi-8MT', 10, _ru_pzrk, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.RUSSIA, 'ПЗРК');
							mission.model.cargoPlaces[_cargo_place_ru1]:addCargoTemplate('minH_ru_car1'.._static_units.name, 'Mi-8MT', 10, _ru_minomet_H, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 }, country.id.RUSSIA, 'Минометы_3');
			-- UH-1	
							mission.model.cargoPlaces[_cargo_place_ru1]:addCargoTemplate('des_ru_car2'.._static_units.name, 'UH-1H', 10, _ru_desants, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 }, country.id.RUSSIA, 'Десант');
							mission.model.cargoPlaces[_cargo_place_ru1]:addCargoTemplate('pzrk_ru_car2'.._static_units.name, 'UH-1H', 10, _ru_pzrk, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 }, country.id.RUSSIA, 'ПЗРК');
							mission.model.cargoPlaces[_cargo_place_ru1]:addCargoTemplate('minL_ru_car2'.._static_units.name, 'UH-1H', 10, _ru_minomet_L, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.RUSSIA, 'Минометы_2');

						end
			-- Ми-8
						if _country.id == country.id.GEORGIA then  --если статик грузинский, то
							local _cargo_place_gr = mission.model:addCargoPlace('Пункт подбора '.._static_units.name, _cargo_place_point, 150, coalition.side[_coalition.name]);--создаем зону погрузки для коалиции, к которой пренадлежит Грузия
							mission.model.cargoPlaces[_cargo_place_gr]:addCargoTemplate('des_gr_car1'.._static_units.name, 'Mi-8MT', 10, _gr_desants, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 }, country.id.GEORGIA, 'Десант');
							mission.model.cargoPlaces[_cargo_place_gr]:addCargoTemplate('pzrk_gr_car1'.._static_units.name, 'Mi-8MT', 10, _gr_pzrk, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.GEORGIA, 'ПЗРК');
							mission.model.cargoPlaces[_cargo_place_gr]:addCargoTemplate('minH_gr_car1'.._static_units.name, 'Mi-8MT', 10, _gr_minomet_H, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 }, country.id.GEORGIA, 'Минометы_3');
			-- UH-1
							mission.model.cargoPlaces[_cargo_place_gr]:addCargoTemplate('des_gr_car2'.._static_units.name, 'UH-1H', 10, _gr_desants, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.GEORGIA, 'Десант');
							mission.model.cargoPlaces[_cargo_place_gr]:addCargoTemplate('pzrk_gr_car2'.._static_units.name, 'UH-1H', 10, _gr_pzrk, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.GEORGIA, 'ПЗРК');
							mission.model.cargoPlaces[_cargo_place_gr]:addCargoTemplate('minL_gr_car2'.._static_units.name, 'UH-1H', 10, _gr_minomet_L, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.GEORGIA, 'Минометы_2');
						end

			-- Ми-8
						if _country.id == country.id.USA then  -- если статик сша, то
							local _cargo_place_us1 = mission.model:addCargoPlace('Пункт подбора '.._static_units.name, _cargo_place_point, 150, coalition.side[_coalition.name]);--создаем зону погрузки для коалиции, к которой пренадлежит США
							mission.model.cargoPlaces[_cargo_place_us1]:addCargoTemplate('des_us_car1'.._static_units.name, 'Mi-8MT', 10, _us_pehota, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 }, country.id.USA, 'Десант');
							mission.model.cargoPlaces[_cargo_place_us1]:addCargoTemplate('pzrk_us_car1'.._static_units.name, 'Mi-8MT', 10, _us_pzrk, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.USA, 'ПЗРК');
							mission.model.cargoPlaces[_cargo_place_us1]:addCargoTemplate('minH_us_car1'.._static_units.name, 'Mi-8MT', 10, _us_minomet_H, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.USA, 'Минометы_3');
			-- UH-1
							mission.model.cargoPlaces[_cargo_place_us1]:addCargoTemplate('des_us_car2'.._static_units.name, 'UH-1H', 10, _us_pehota, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.USA, 'Десант');
							mission.model.cargoPlaces[_cargo_place_us1]:addCargoTemplate('pzrk_us_car2'.._static_units.name, 'UH-1H', 10, _us_pzrk, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.USA, 'ПЗРК');
							mission.model.cargoPlaces[_cargo_place_us1]:addCargoTemplate('minL_us_car2'.._static_units.name, 'UH-1H', 10, _us_minomet_L, 12, 10, { altitudeLessThen = 5, speedLessThen = 4, command = 0 },	country.id.USA, 'Минометы_2');
						end		
					end
				end
			end
		end
	end
end

local _gruz_zone_list = {};
local _gruz_list = {};
for i = 900, 919 do --20 зон
	local _gruz_zone = trigger.misc.getZone(i);
	if _gruz_zone ~= nil then
		local _count = 0;
		for j = 1, 10 do --до 10 грузов для каждой зоны
			local _gruz_static = StaticObject.getByName(i..'_'..j);
			if _gruz_static ~= nil then
				table.insert(_gruz_list, { Name = i..'_'..j});
				_count = _count + 1;
			end
		end
		table.insert(_gruz_zone_list, { Name = i, Count = _count});
	end
end

local customEventHandler = {};

function customEventHandler:onEvent(event)

	if world.event.S_EVENT_EJECTION == event.id then
	
		local _eject_object 		= event.initiator; 				-- самолет с которого катапультировались
		local _eject_object_coal	= _eject_object:getCoalition(); -- коалиция самолета
		local _eject_point 			= _eject_object:getPoint(); 	-- координаты катапультирования
		local _eject_object_name	= _eject_object:getName();      -- имя самолета, с которого катапультировались
		local _pilotname = 'eject_'.._eject_object_name..'_'..string.format("%.0f",timer.getTime());	-- имя очередного катапультанта
		local _pilotUnitType; 						-- тип наземного юнита
		local _pilotCountry; 						-- страна наземного юнита
		local _radioTRfreq;
		
--		устанавливаем страну и тип наземного юнита, название и частоту его радиотриггера в соответствии с коалицией
		if _eject_object_coal == coalition.side.RED then
			_pilotUnitType	= 'Infantry AK';
			_pilotCountry 	= country.id.RUSSIA;
			_radioTRfreq = 121500000;
		else
			_pilotUnitType	= 'Soldier M4';
			_pilotCountry 	= country.id.USA;
			_radioTRfreq = 500000;	--243 хьуй не ловит, а 500КГц раньше использовали как аварийную.
		end
		
		local _units = {};
		
		table.insert(_units, { unitType = _pilotUnitType, unitName = _pilotname, playerCanDrive = false, point = { x = _eject_point.x + 10, y = _eject_point.z + 10} }); -- описание наземного юнита
		
		local _eject_pilot_grp_desc = mission.utils.getGroupDescriptor(_pilotname, _eject_point, _units); -- описание группы наземного юнита
		
		local _fall_time = 120; -- время спуска на парашюте
		
		timer.scheduleFunction(
		function()
		
			local _status, _result = pcall(function() -- создание наземного объекта
				local _eject_pilot_grp = mission.model:createGroup(Group.Category.GROUND, _pilotCountry, _eject_pilot_grp_desc);	
				return _eject_pilot_grp;
			end);
		 
			local _dcsw_group = _result:getDCSWorldGroup(); -- получаем объект SSE из MSF объекта
			
			_result:addAvalibleTransport('UH-1H');  -- назначаем типы транспортных вертолетов
			_result:addAvalibleTransport('Mi-8MT');
			
			local _units = _dcsw_group:getUnits(); -- получаем массив юнитов группы
			local _pilot = _units[1];  -- получаем юнит

			local _pilot_point = _pilot:getPoint(); -- координаты пилота
--------------------------------------------------------------------------- небольшой hack, так как решение не подходит для MSF
			do
				local _cargo_template = {};
			
				_cargo_template.units = {};
		
				table.insert(_cargo_template.units, { unitType = _pilot:getTypeName(), playerCanDrive = false, pointOffset = { x = 10, y = 10 } });
				
				_cargo_template.unloadTime = 2;
				_cargo_template.groupName = _dcsw_group:getName();
				_cargo_template.cargoPlace = { point = { x = 100, y = 100, z = 100 }, radius = 200 };
				_cargo_template.countryId = _pilot:getCountry();
				_cargo_template.conditions = { altitudeLessThen = 5, speedLessThen = 4, command = 0 };
				
				_result.groupTemplate = _cargo_template; -- собсно hack
			end
----------------------------------------------------------------------------
			timer.scheduleFunction(
			function(_data) -- создаем автономную задачу поведения катапультанта
			
				if not (_data.pilot and _data.pilot:isExist()) then
					trigger.action.stopRadioTransmission(_pilotname);
					trigger.action.stopRadioTransmission(_pilotname..'_243');
					return nil; 
				end	-- проверим, жив ли наш пилот, если мертв удаляем задачу
				
--				--радиомаяк триггером (аудиофайл, коорд. источника, ФМ/АМ, повтор, частота, мощность, название триггера)
				trigger.action.radioTransmission('continue.ogg', _pilot_point, radio.modulation.AM , false, _radioTRfreq, 1, _pilotname);
				if _pilotCountry == country.id.USA then
					trigger.action.radioTransmission('continue.ogg', _pilot_point, radio.modulation.AM , false, 243000000, 1, _pilotname..'_243');--mi8 синий
				end
				
--				если живой, то получаем область видимости юнита
				local _volume = {
					id = world.VolumeType.SPHERE, -- крутит головой на 360
					params = {
						point = _data.point,
						radius = 5000 -- расстояние, на которое видит юнит
					}
				};
				
				local _smoke_time = 0;
--				выполним поиск объекта в заданной области видимости: тип объектов для поиска - юниты, область поиска - сфера, + обработчик результатов поиска, + данные
				world.searchObjects(Object.Category.UNIT, _volume,
				function(_object, _data)
				
					if _object == _data.pilot or not _object:inAir() then
						return true;
					end

					local _pilot_Coalition = _data.pilot:getCoalition(); -- коалиция юнита
					local _obj_Coalition = _object:getCoalition(); -- коалиция найденного объекта
					local _obj_Type = _object:getTypeName();
				
					if not(_obj_Coalition == _pilot_Coalition) then -- если найденный объект враг, то подождем
						return false;
					end
--					найденый объект дружественный, надо дать знать о себе и вычисляем расстояние

					local _obj_point = _object:getPoint();
					local _distance = math.sqrt( (_obj_point.x - _data.point.x)^2 + (_obj_point.z - _data.point.z)^2);
				
--					если близко, даем дым
					if _distance < 600 and (_obj_Type == "UH-1H" or _obj_Type == "Mi-8MT") then
						local _smoke_point = { x = _data.point.x + 10, y = _data.point.y - 5, z = _data.point.z + 10};
						trigger.action.smoke(_smoke_point, trigger.smokeColor.Orange);
						trigger.action.stopRadioTransmission(_pilotname);
						trigger.action.stopRadioTransmission(_pilotname..'_243');
						_smoke_time = 280;
						return false;
					end
					
--					если далеко - пускаем сигнальные ракеты
					trigger.action.signalFlare(_data.point, trigger.flareColor.Red, 0);
					_smoke_time = 0;
					
					return false;
				
				end, _data);
				return timer.getTime() + _smoke_time + 20; -- время повторения поиска
			
			end, {pilot = _pilot, point = _pilot_point}, timer.getTime() + 30); -- задержка выполнения (нужно прийти в себя после приземления)
		end, {}, timer.getTime()+_fall_time); -- время полета до земли
	end;
	
	if world.event.S_EVENT_BIRTH == event.id then
		local _birth_object = event.initiator;
		local _unit_desc = Unit.getDesc(_birth_object);
		if Unit.Category.HELICOPTER == _unit_desc.category then
			local _status, _initiator_name = pcall(function() local _name = event.initiator:getName(); return _name; end);
			if not _status then
				env.error('MSF ERROR: Could not get initiator name of event S_EVENT_BIRTH, cause of ' .. tostring(_initiator_name), false);
				return;
			end
			if not mission.model.units[_initiator_name] then
				mission.model:addUnit(_initiator_name);
			end
			for _static_radios_index, _static_radio_point in ipairs(_static_radios_list) do
				trigger.action.stopRadioTransmission(_static_radio_point.radioName);
				trigger.action.radioTransmission(_static_radio_point.radioSound, _static_radio_point.radioPosition, _static_radio_point.radioModulation, _static_radio_point.repeatTransmit, _static_radio_point.radioFrequency, _static_radio_point.radioPower, _static_radio_point.radioName);
			end
		end
	end
	
	if world.event.S_EVENT_TAKEOFF == event.id then
		local _object = event.initiator;
		local _unit_desc = Unit.getDesc(_object);
		local _obj_type = _object:getTypeName();
		if Unit.Category.HELICOPTER == _unit_desc.category and (_obj_type == "UH-1H" or _obj_type == "Mi-8MT") then
			local _status, _initiator_name = pcall(function() local _name = event.initiator:getName(); return _name; end);
			if not _status then
				env.error('MSF ERROR: Could not get initiator name of event S_EVENT_TAKEOFF, cause of ' .. tostring(_initiator_name), false);
				return;
			end
			if not mission.model.units[_initiator_name] then
				mission.model:addUnit(_initiator_name);
			end
			local _unit = mission.model.units[_initiator_name];
			if _unit ~= nil then
				_unit:setTransportTask(true);
				if not _unit:isExistRadioMenuItem('optional_' .. 'submenu') then
					local _radio_optional_menu = _unit:addRadioCommand('optional_' .. 'submenu', 'Дополнительно', true, nil, nil, nil);
					local _radio_drop_smoke = _unit:addRadioCommand('optional_' .. 'submenu'..'_smoke', 'Бросить дымовую шашку', false, 
						function(_data)
							local _dcsw_unit = Unit.getByName(_data.Name);
							local _point = _dcsw_unit:getPoint();
							trigger.action.smoke({ x = _point.x, y = land.getHeight({ x = _point.x, y = _point.z }), z = _point.z }, trigger.smokeColor.White);
						end, {Name = _initiator_name}, _radio_optional_menu);
				end
			end
		end
	end
end;

world.addEventHandler(customEventHandler);

local function SearchGruz()
	timer.scheduleFunction(
	function()
		for _zone_index, _zone in ipairs(_gruz_zone_list) do
			local _gruz_inside = 0;
			local _current_zone = trigger.misc.getZone(_zone.Name);
			for _gruz_index, _gruz in ipairs(_gruz_list) do
				local _gruz_of_zone = string.find(_gruz.Name, _zone.Name);
				if _gruz_of_zone ~= nil then
					local _current_gruz= StaticObject.getByName(_gruz.Name);
					local _gruz_point = _current_gruz:getPoint();
					local _distance = math.sqrt(((_gruz_point.x - _current_zone.point.x)^2) + ((_gruz_point.z - _current_zone.point.z)^2));
					local _zone_height = land.getHeight({ x = _current_zone.point.x, y = _current_zone.point.z });
					if _distance < _current_zone.radius and _gruz_point.y < (_zone_height + 2) then
						table.remove(_gruz_list, _gruz_index);
						_gruz_inside = _gruz_inside + 1;
					end
				end
			end
			if _gruz_inside > 0 then
				local _current_count = _zone.Count - _gruz_inside;
				if _current_count == 0 then
					trigger.action.setUserFlag(_zone.Name, 1);
				else
					table.insert(_gruz_zone_list, { Name = _zone.Name, Count = _current_count});
				end
				table.remove(_gruz_zone_list, _zone_index);
			end
		end
		if #_gruz_zone_list > 0 then
			return timer.getTime() + 20;
		else
			return false;
		end
	end, {}, timer.getTime() + 5);
end;

local function StartRadio()
	timer.scheduleFunction(
	function()
		for _veh_radios_index, _veh_radio_point in ipairs(_veh_radios_list) do
			trigger.action.stopRadioTransmission(_veh_radio_point.radioName);
			local _dcsw_unit = Unit.getByName(_veh_radio_point.radioName);
			if _dcsw_unit ~= nil then
				local _unit_velocity = _dcsw_unit:getVelocity();
				if _veh_radio_point.transmitOnMove or (_unit_velocity.x + _unit_velocity.z) == 0 then
					local _unit_position = _dcsw_unit:getPoint();
					local _unit_radio_pos = { x = _unit_position.x, y = 200, z = _unit_position.z};
					trigger.action.radioTransmission(_veh_radio_point.radioSound, _unit_radio_pos, _veh_radio_point.radioModulation, _veh_radio_point.repeatTransmit, _veh_radio_point.radioFrequency, _veh_radio_point.radioPower, _veh_radio_point.radioName);
				end
			else
				table.remove(_veh_radios_list, _veh_radios_index);
			end
		end
		if #_veh_radios_list > 0 then
			return timer.getTime() + 10;
		else
			return false;
		end
	end, {}, timer.getTime() + 5);
end;

if #_gruz_zone_list > 0 then SearchGruz(); end
if #_veh_radios_list > 0 then StartRadio(); end

trigger.action.outText("Скрипт L_E_R от 25.06.2015 успешно запущен", 5);
mission.controller:start();
--== Load & Eject & Radio ==--
--Created by Chichco, based on StarLey Andrew's script--